#include "ai_usb.h"
#include "set_task.h"
#include <STC32G.H>

// PWMΪP60~P67ֱӦPWM1PPWM1NPWM2PPWM2NPWM3PPWM3NPWM4PPWM4N
// PWMΪP32INT0P33INT1P00PWM5PP02PWM7P

unsigned int ccr1;
unsigned int ccr3;
unsigned int ccr5;
unsigned int ccr7;
unsigned int high_level_time1;
unsigned int high_level_time2;
unsigned int high_level_time3;
unsigned int high_level_time4;
bit f1, f2, f3, f4;

void Pwm_Out_Init(void)
{
    EAXFR = 1;         // չĴ(XFR)ʹ
    PWMA_PS = 0xaa;    // PWMAл
    PWMA_CCER1 = 0x00; // д CCMRx ǰ CCxE رͨ
    PWMA_CCER2 = 0x00;
    PWMA_CCMR1 = 0x60;
    PWMA_CCMR2 = 0x60;
    PWMA_CCMR3 = 0x60;
    PWMA_CCMR4 = 0x60;
    PWMA_CCER1 = 0x55;
    PWMA_CCER2 = 0x55;
    PWMA_CCMR1 = 0x68;
    PWMA_CCMR2 = 0x68;
    PWMA_CCMR3 = 0x68;
    PWMA_CCMR4 = 0x68;
    PWMA_PSCRH = 0x00;
    PWMA_PSCRL = 0x01;
    PWMA_ARRH = 0x4e;
    PWMA_ARRL = 0x20;
    PWMA_CCR1H = 0x27;
    PWMA_CCR1L = 0x10;
    PWMA_CCR2H = 0x27;
    PWMA_CCR2L = 0x10;
    PWMA_CCR3H = 0x27;
    PWMA_CCR3L = 0x10;
    PWMA_CCR4H = 0x27;
    PWMA_CCR4L = 0x10;
    PWMA_ENO = 0xff; // PWMAʹ
    PWMA_BKR = 0x80; // ʹ
    PWMA_CR1 = 0x81; // ʹARRԤװ,ʼʱ
}

void Pwm_In_Init(void)
{
    PWMB_PS = 0xaa; // PWMBл
    PWMB_CCER1 = 0x00;
    PWMB_CCMR1 = 0x01;
    // CC5 Ϊģʽ,ӳ䵽 TI5FP5 
    PWMB_CCMR2 = 0x02;
    // CC6 Ϊģʽ,ӳ䵽 TI5FP6 
    PWMB_CCER1 = 0x11;
    // ʹ CC5 ϵĲ,ʹ CC6 ϵĲ
    PWMB_CCER1 |= 0x00;
    // òΪ CC5 
    PWMB_CCER1 |= 0x20;
    // òΪ CC6 ½
    PWMB_CCER2 = 0x00;
    PWMB_CCMR3 = 0x01;
    // CC7 Ϊģʽ,ӳ䵽 TI7FP8 
    PWMB_CCMR4 = 0x02;
    // CC8 Ϊģʽ,ӳ䵽 TI7FP8 
    PWMB_CCER2 = 0x11;
    // ʹ CC7 ϵĲ,ʹ CC8 ϵĲ
    PWMB_CCER2 |= 0x00;
    // òΪ CC7 
    PWMB_CCER2 |= 0x20;
    // òΪ CC8 ½
    PWMB_CR1 = 0x01;
    PWMB_IER = 0x1e;
    // ʹ CC5/CC6/CC7/CC8 ж
}

void UpdatePwm(unsigned char num, unsigned int duty)
{
    if (num <= 3 && duty > 20000)
        return; // dutyaԳ20000
    if (num >= 4 && duty > 0)
        return; // dutybԳ0
    switch (num)
    {
    case 1:
        PWMA_CCR1H = (unsigned char)(duty >> 8); // ռձʱ
        PWMA_CCR1L = (unsigned char)(duty);
        break;
    case 2:
        PWMA_CCR2H = (unsigned char)(duty >> 8); // ռձʱ
        PWMA_CCR2L = (unsigned char)(duty);
        break;
    case 3:
        PWMA_CCR3H = (unsigned char)(duty >> 8); // ռձʱ
        PWMA_CCR3L = (unsigned char)(duty);
        break;
    case 4:
        PWMA_CCR4H = (unsigned char)(duty >> 8); // ռձʱ
        PWMA_CCR4L = (unsigned char)(duty);
        break;
    default:
        break;
    }
}

void Int_Timer_Init(void)
{
    T0x12 = 1;
    // 1T ģʽ
    TL0 = 0x00;
    TH0 = 0x00;
    T1x12 = 1;
    // 1T ģʽ
    TMOD = 0x88;
    // ʹ GATE,INT1 Ϊ 1 ʱʹܼʱINT0 Ϊ 1 ʱʹܼʱ
    TL1 = 0x00;
    TH1 = 0x00;
}

void Timer2_Isr(void) interrupt 12
{
    set_task_mode(); // Эʱ׼
}

void Timer2_Init(void) // 1@40.000MHz
{
    AUXR |= 0x04; // ʱʱ1Tģʽ
    T2L = 0xC0;   // öʱʼֵ
    T2H = 0x63;   // öʱʼֵ
    AUXR |= 0x10; // ʱ2ʼʱ
    IE2 |= 0x04;  // ʹܶʱ2ж
}

void main(void)
{
    EAXFR = 1;
    // ʹܷ XFR,ûгͻùر
    CKCON = 0x00;
    // ⲿٶΪ
    WTST = 0x00;
    // óȴ
    // ֵΪ 0 ɽ CPU ִгٶΪ
    P6M0 = 0x00;
    P6M1 = 0x00;
    P3PU |= 0x0c;
    P0PU |= 0x05;
    Pwm_Out_Init();
    Pwm_In_Init();
    Int_Timer_Init();
    Timer2_Init();
    usb_init();
    EA = 1;
    while (1)
    {
        task_start(0);  // Э0
        task_wait(P32); // ȴ INT0 Ϊ
        TR0 = 1;
        // ʱ
        IT0 = 1;
        // ʹ INT0 ½ж
        EX0 = 1;
        f1 = 1;
        task_wait(f1);                       // ȴȡ
        UpdatePwm(1, high_level_time1 >> 2); // 0~16384
        printf_usb("h1:%u\r\n", high_level_time1);
        task_delay(100);
        task_end(1);

        task_start(1);  // Э1
        task_wait(P33); // ȴ INT1 Ϊ
        TR1 = 1;
        // ʱ
        IT1 = 1;
        // ʹ INT1 ½ж
        EX1 = 1;
        f2 = 1;
        task_wait(f2);                       // ȴȡ
        UpdatePwm(2, high_level_time2 >> 2); // 0~16384
        printf_usb("h2:%u\r\n", high_level_time2);
        task_delay(100);
        task_end(1);

        task_start(2); // Э2
        f3 = 1;
        task_wait(f3);
        UpdatePwm(3, high_level_time3 >> 2); // 0~16384
        printf_usb("h3:%u\r\n", high_level_time3);
        task_delay(100);
        task_end(1); // ѭִ

        task_start(3); // Э3
        f4 = 1;
        task_wait(f4);
        UpdatePwm(4, high_level_time4 >> 2); // 0~16384
        printf_usb("h4:%u\r\n", high_level_time4);
        task_delay(100);
        task_end(1); // ѭִ
    }
}

void INT0_Isr() interrupt 0
{
    high_level_time1 = ((unsigned int)TH0 << 8) | TL0;
    TR0 = 0;
    TL0 = 0x00;
    TH0 = 0x00;
    f1 = 0;
}

void INT1_Isr() interrupt 2
{
    high_level_time2 = ((unsigned int)TH1 << 8) | TL1;
    TR1 = 0;
    TL1 = 0x00;
    TH1 = 0x00;
    f2 = 0;
}

void PWMB_ISR() interrupt PWMB_VECTOR
{
    unsigned int ccr;
    if (PWMB_SR1 & 0x02)
    // CC5 ж
    {
        PWMB_SR1 &= ~0x02;
        ccr = (PWMB_CCR5H << 8) + PWMB_CCR5L;
        // ȡֵ
        ccr5 = ccr;
        // 浱ǰֵ
    }
    if (PWMB_SR1 & 0x04)
    // CC6 ж
    {
        PWMB_SR1 &= ~0x04;
        ccr = (PWMB_CCR6H << 8) + PWMB_CCR6L;
        // ȡֵ
        high_level_time3 = ccr - ccr5;
        // ߵƽʱ
        f3 = 0;
        //  3 
    }
    if (PWMB_SR1 & 0x08)
    // CC7 ж
    {
        PWMB_SR1 &= ~0x08;
        ccr = (PWMB_CCR7H << 8) + PWMB_CCR7L;
        // ȡֵ
        ccr7 = ccr;
        // 浱ǰֵ
    }
    if (PWMB_SR1 & 0x10)
    // CC8 ж
    {
        PWMB_SR1 &= ~0x10;
        ccr = (PWMB_CCR8H << 8) + PWMB_CCR8L;
        // ȡֵ
        high_level_time4 = ccr - ccr7;
        // ߵƽʱ
        f4 = 0;
        //  4 
    }
}